﻿//
// MainPage.xaml.h
// Declaration of the MainPage class.
//

#pragma once

#include "MainPage.g.h"
#include "AudioFilePlayer.h"
#include "OneThirdOctaveEqualizerEffect.h"
#include "OneThirdOctaveEqualizerParameters.h"

namespace GraphicEqualizer2
{
    public ref class MainPage sealed
    {
    private:
        Microsoft::WRL::ComPtr<IXAudio2> pXAudio2;
        IXAudio2MasteringVoice * pMasteringVoice;
        AudioFilePlayer * pAudioFilePlayer;
        OneThirdOctaveEqualizerParameters equalizerParams;

    public:
        MainPage();

    private:
        void OnOpenButtonClick(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ args);
        void OnPlayButtonClick(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ args);
        void OnPauseButtonClick(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ args);
        void OnVolumeSliderValueChanged(Platform::Object^ sender, Windows::UI::Xaml::Controls::Primitives::RangeBaseValueChangedEventArgs^ args);

        void OnEqualizerInOutButtonClick(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ args);
        void OnEqualizerSliderChanged(Platform::Object^ sender, Windows::UI::Xaml::Controls::Primitives::RangeBaseValueChangedEventArgs^ args);
    };
}
