#pragma once

class OneThirdOctaveEqualizerEffect sealed : public CXAPOParametersBase
{
private:
    static const XAPO_REGISTRATION_PROPERTIES RegistrationProps;
    byte * pParameterBlocks;

    WAVEFORMATEX waveFormat;
    float Q;
    float a0[26], a1[26], a2[26], b0[26], b1[26], b2[26];
    float * pxp, * pxpp, * pyp, * pypp;

public:
    static OneThirdOctaveEqualizerEffect * Create();
    ~OneThirdOctaveEqualizerEffect();

private:
    void FreeArrays();

protected:
    OneThirdOctaveEqualizerEffect(const XAPO_REGISTRATION_PROPERTIES * pRegProperties, 
                                  BYTE * pParameterBlocks,
                                  UINT32 uParameterBlockByteSize,
                                  BOOL fProducer);

    virtual HRESULT __stdcall LockForProcess(UINT32 inpParamCount,
                                             const XAPO_LOCKFORPROCESS_BUFFER_PARAMETERS  *pInpParams,
                                             UINT32 outParamCount,
                                             const XAPO_LOCKFORPROCESS_BUFFER_PARAMETERS  *pOutParam) override;

    virtual void __stdcall Process(UINT32 inpParameterCount,
                                   const XAPO_PROCESS_BUFFER_PARAMETERS *pInpParams,
                                   UINT32 outParameterCount,
                                   XAPO_PROCESS_BUFFER_PARAMETERS *pOutParams,
                                   BOOL isEnabled) override;
};

class __declspec(uuid("8417ACD4-2617-400D-9BC5-C46AE528D77E")) OneThirdOctaveEqualizerEffect;
