﻿//
// MainPage.xaml.h
// Declaration of the MainPage class.
//

#pragma once

#include "MainPage.g.h"
#include "AudioFilePlayer.h"
#include "OneSecondEchoEffect.h"
#include "OneSecondTremoloEffect.h"

namespace SimpleEffectDemo
{
    public ref class MainPage sealed
    {
    private:
        Microsoft::WRL::ComPtr<IXAudio2> pXAudio2;
        IXAudio2MasteringVoice * pMasteringVoice;
        AudioFilePlayer * pAudioFilePlayer;

    public:
        MainPage();

    private:
        void OnOpenButtonClick(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ args);
        void OnPlayButtonClick(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ args);
        void OnPauseButtonClick(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ args);
        void OnVolumeSliderValueChanged(Platform::Object^ sender, Windows::UI::Xaml::Controls::Primitives::RangeBaseValueChangedEventArgs^ args);

        void OnTremoloToggleChecked(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ args);
        void OnEchoToggleChecked(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ args);

        void EnableDisableEffect(Windows::UI::Xaml::Controls::Primitives::ToggleButton^ toggle, int index);
    };
}
