#pragma once

class OneSecondEchoEffect sealed : public CXAPOBase
{
private:
    static const XAPO_REGISTRATION_PROPERTIES RegistrationProps;
    WAVEFORMATEX waveFormat;
    std::vector<float> delayBuffer;
    int delayLength;
    int delayIndex;

public:
    OneSecondEchoEffect() : CXAPOBase(&RegistrationProps)
    {
    }

protected:
    virtual HRESULT __stdcall LockForProcess(UINT32 inpParamCount,
                                             const XAPO_LOCKFORPROCESS_BUFFER_PARAMETERS  *pInpParams,
                                             UINT32 outParamCount,
                                             const XAPO_LOCKFORPROCESS_BUFFER_PARAMETERS  *pOutParams) override;

    virtual void __stdcall Process(UINT32 inpParamCount,
                                   const XAPO_PROCESS_BUFFER_PARAMETERS *pInpParams,
                                   UINT32 outParamCount,
                                   XAPO_PROCESS_BUFFER_PARAMETERS *pOutParams,
                                   BOOL isEnabled) override;
};

class __declspec(uuid("ED566395-65E8-4B25-9E75-395EEA67A7A4")) OneSecondEchoEffect;




// }
