#pragma once

class OneSecondTremoloEffect sealed : public CXAPOBase
{
private:
    static const XAPO_REGISTRATION_PROPERTIES RegistrationProps;
    WAVEFORMATEX waveFormat;
    int tremoloIndex;

public:
    OneSecondTremoloEffect() : CXAPOBase(&RegistrationProps),
                               tremoloIndex(0)
    {
    }

protected:
    virtual HRESULT __stdcall LockForProcess(
                UINT32 inpParamCount,
                const XAPO_LOCKFORPROCESS_BUFFER_PARAMETERS  *pInpParams,
                UINT32 outParamCount,
                const XAPO_LOCKFORPROCESS_BUFFER_PARAMETERS  *pOutParam) override;

    virtual void __stdcall Process(
                UINT32 inpParameterCount,
                const XAPO_PROCESS_BUFFER_PARAMETERS *pInpParams,
                UINT32 outParamCount,
                XAPO_PROCESS_BUFFER_PARAMETERS *pOutParams,
                BOOL isEnabled) override;
};

class __declspec(uuid("6FB2EBA3-7DCB-4ADF-9335-686782C49911")) OneSecondTremoloEffect;
